;; $Id: dbblock.dsl 0.1 1997/07/31 14:51:33 nwalsh Exp $

(element HIGHLIGHTS ($block-container$))

(element BLOCKQUOTE
  (make element gi: "BLOCKQUOTE"
	(process-children-trim)))

(element EPIGRAPH ($block-container$))

(element ATTRIBUTION ($paragraph$))

(element PARA ($paragraph$))
(element SIMPARA ($paragraph$))

(element FORMALPARA
  (make element gi: "DIV"
	attributes: (list
		     (list "CLASS" (gi)))
	(process-children)))

(element (FORMALPARA TITLE)
  (make element gi: "P"
	(make element gi: "B"
	      (process-children-trim))))

(element (FORMALPARA PARA)
  ($paragraph$))

(element SIDEBAR ($block-container$))
(element ABSTRACT ($block-container$))
(element AUTHORBLURB ($block-container$))

(element EXAMPLE 
  (make element gi: "DIV"
	attributes: (list
		     (list "CLASS" (gi)))
	(with-mode block-caption-mode
	  (process-first-descendant "TITLE"))
	(process-children)))

(element (EXAMPLE TITLE) (empty-sosofo)) ; don't show caption below example
(element INFORMALEXAMPLE ($block-container$))

(element (FIGURE TITLE) (empty-sosofo)) ; don't show caption below figure

(element FIGURE 
  (make element gi: "DIV"
	attributes: (list
		     (list "CLASS" (gi)))
	(with-mode block-caption-mode
	  (process-first-descendant "TITLE"))
	(process-children)))

(mode block-caption-mode
  (element TITLE
    (let* ((label (attribute-string "label" (ancestor (gi (parent)))))
	   (chn (ancestor-child-number "CHAPTER"))
	   (apn (ancestor-child-number "APPENDIX"))
	   (num (format-number (element-number (parent (current-node))) "1"))
	   (pnn (cond
		 (chn (FNUM chn))
		 (apn (FNUM apn))
		 (else "")))
	   (prefix (if (equal? pnn "") 
		       "" 
		       (string-append pnn (gentext-intra-label-sep 
					   (gi (parent)))))))
      (make element gi: "P"
	    (make element gi: "B"
		  (literal
		   (string-append
		    (gentext-element-name-space (gi (parent (current-node))))
		    (if label
			label
			(string-append prefix num))
		    (gentext-label-title-sep (gi (parent (current-node))))))
		  (process-children-trim))))))

